blob: f79c71c64f0097d008d5e5f4a0949cdd1e56182e [file] [log] [blame]
Josh Coalson60d9d012001-05-27 18:32:15 +00001#!/bin/sh
2
Josh Coalson6b05bc52001-06-08 00:13:21 +00003# FLAC - Free Lossless Audio Codec
Josh Coalson1152f9f2002-01-26 18:05:12 +00004# Copyright (C) 2001,2002 Josh Coalson
Josh Coalson6b05bc52001-06-08 00:13:21 +00005#
6# This program is part of FLAC; you can redistribute it and/or
7# modify it under the terms of the GNU General Public License
8# as published by the Free Software Foundation; either version 2
9# of the License, or (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program; if not, write to the Free Software
18# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
19
Josh Coalson6218b342002-12-12 03:58:18 +000020die ()
21{
22 echo $* 1>&2
23 exit 1
24}
25
Josh Coalson48404ff2002-11-21 08:58:52 +000026LD_LIBRARY_PATH=../src/libFLAC/.libs:../obj/release/lib:../obj/debug/lib:$LD_LIBRARY_PATH
Josh Coalson60d9d012001-05-27 18:32:15 +000027export LD_LIBRARY_PATH
Josh Coalson34c1ea82002-12-04 04:57:33 +000028PATH=../src/flac:../obj/release/bin:../obj/debug/bin:$PATH
Josh Coalson60d9d012001-05-27 18:32:15 +000029BINS_PATH=../../test_files/bins
30
Josh Coalson6218b342002-12-12 03:58:18 +000031flac --help 1>/dev/null 2>/dev/null || die "ERROR can't find flac executable"
Josh Coalson94b22e02002-10-11 06:22:30 +000032
Josh Coalson34c1ea82002-12-04 04:57:33 +000033run_flac ()
34{
35 if [ "$FLAC__VALGRIND" = yes ] ; then
36 valgrind --leak-check=yes --show-reachable=yes --num-callers=10 --logfile-fd=4 flac $* 4>>valgrind.log
37 else
38 flac $*
39 fi
40}
Josh Coalson94b22e02002-10-11 06:22:30 +000041
Josh Coalson21f692b2001-07-22 07:25:50 +000042test -d ${BINS_PATH} || exit 77
43
Josh Coalson60d9d012001-05-27 18:32:15 +000044test_file ()
45{
46 name=$1
47 channels=$2
48 bps=$3
49 encode_options="$4"
50
Josh Coalson9b145182002-08-30 05:39:36 +000051 echo -n "$name (--channels=$channels --bps=$bps $encode_options): encode..."
Josh Coalson34c1ea82002-12-04 04:57:33 +000052 cmd="run_flac --verify --silent --force-raw-format --endian=big --sign=signed --sample-rate=44100 --bps=$bps --channels=$channels $encode_options $name.bin"
Josh Coalson60d9d012001-05-27 18:32:15 +000053 echo "### ENCODE $name #######################################################" >> ./streams.log
54 echo "### cmd=$cmd" >> ./streams.log
Josh Coalson6218b342002-12-12 03:58:18 +000055 $cmd 2>>./streams.log || die "ERROR during encode of $name"
56
Josh Coalson60d9d012001-05-27 18:32:15 +000057 echo -n "decode..."
Josh Coalson34c1ea82002-12-04 04:57:33 +000058 cmd="run_flac --silent --endian=big --sign=signed --decode --force-raw-format $name.flac";
Josh Coalson60d9d012001-05-27 18:32:15 +000059 echo "### DECODE $name #######################################################" >> ./streams.log
60 echo "### cmd=$cmd" >> ./streams.log
Josh Coalson6218b342002-12-12 03:58:18 +000061 $cmd 2>>./streams.log || die "ERROR during decode of $name"
62
Josh Coalson60d9d012001-05-27 18:32:15 +000063 ls -1l $name.bin >> ./streams.log
64 ls -1l $name.flac >> ./streams.log
65 ls -1l $name.raw >> ./streams.log
Josh Coalson6218b342002-12-12 03:58:18 +000066
Josh Coalson60d9d012001-05-27 18:32:15 +000067 echo -n "compare..."
Josh Coalson6218b342002-12-12 03:58:18 +000068 cmp $name.bin $name.raw || die "ERROR during compare of $name"
69
Josh Coalson60d9d012001-05-27 18:32:15 +000070 echo OK
71}
72
73echo "Testing bins..."
Josh Coalson94b22e02002-10-11 06:22:30 +000074for f in b00 b01 b02 b03 b04 ; do
75 binfile=$BINS_PATH/$f
76 if [ -f $binfile ] ; then
77 for disable in '' '--disable-verbatim-subframes --disable-constant-subframes' '--disable-verbatim-subframes --disable-constant-subframes --disable-fixed-subframes' ; do
78 for channels in 1 2 4 8 ; do
79 for bps in 8 16 24 ; do
80 for opt in 0 1 2 4 5 6 8 ; do
81 for extras in '' '-p' '-e' ; do
82 for blocksize in '' '--lax -b 32' '--lax -b 32768' '--lax -b 65535' ; do
83 test_file $binfile $channels $bps "-$opt $extras $blocksize $disable"
84 done
85 done
Josh Coalson60d9d012001-05-27 18:32:15 +000086 done
Josh Coalson94b22e02002-10-11 06:22:30 +000087 if [ "$FLAC__EXHAUSTIVE_TESTS" = yes ] ; then
88 test_file $binfile $channels $bps "-b 16384 -m -r 8 -l 32 -e -p $disable"
89 fi
Josh Coalson60d9d012001-05-27 18:32:15 +000090 done
91 done
Josh Coalson60d9d012001-05-27 18:32:15 +000092 done
Josh Coalson94b22e02002-10-11 06:22:30 +000093 else
94 echo "$binfile not found, skipping."
95 fi
Josh Coalson60d9d012001-05-27 18:32:15 +000096done